#! /usr/bin node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commander_jsx_1 = require("commander-jsx");
const loader_1 = require("./loader");
process.on('unhandledRejection', error => {
    console.error(error);
    process.exit();
});
commander_jsx_1.Command.execute((0, commander_jsx_1.createCommand)(commander_jsx_1.Command, { name: "web-fetch", version: "1.2.0", description: "Web page fetcher", parameters: "<source URL> [target folder] [options]", options: {
        rootSelector: {
            shortcut: 's',
            parameters: '<selector>',
            description: 'CSS Selector of Root HTML Container'
        },
        baseURI: {
            shortcut: 'b',
            parameters: '<URL>',
            description: 'Base URL of fetched HTML assets'
        },
        markdown: {
            shortcut: 'm',
            description: 'Whether converts HTML to MarkDown'
        }
    }, executor: async ({ rootSelector, baseURI, markdown }, source, rootFolder) => {
        await (0, loader_1.savePage)({
            source,
            rootSelector,
            baseURI,
            markdown,
            rootFolder
        });
        process.exit();
    } }), process.argv.slice(2));
