/// <reference types="node" />
import Puppeteer, { Browser } from 'puppeteer-core';
import { JSDOM } from 'jsdom';
import { meta_tag } from './config';
import { MetaData } from './parser';
export declare const getBrowser: () => Promise<Browser>;
export declare function getPage(): Promise<Puppeteer.Page>;
export declare function loadPage(URI: string, root_selector?: string): Promise<JSDOM>;
export interface MediaItem {
    MIME: string;
    name: string;
    data: Buffer;
}
export declare function fetchMedia(root: HTMLElement, root_path?: string): AsyncGenerator<{
    MIME: string;
    name: string;
    data: Buffer;
}, void, unknown>;
export declare function fixBaseURI(document: Document, baseURI: string): void;
export interface AssetFetchOption {
    scope: string;
    rootSelector?: string;
    baseURI?: string;
    markdown?: boolean;
}
export declare function fetchAsset(document: Document, { scope, rootSelector, baseURI, markdown }: AssetFetchOption, meta?: MetaData<typeof meta_tag>): AsyncGenerator<MediaItem, void, unknown>;
export interface PageSaveOption extends Omit<AssetFetchOption, 'scope'> {
    source: string;
    rootFolder?: string;
}
export declare function savePage({ source, rootSelector, baseURI, markdown, rootFolder }: PageSaveOption): Promise<void>;
